"use strict";

const CONSTANTS = {
  // 定时任务状态
  SCHEDULE_STATUS: {
    // 上线
    RUN: 2,
    // 下线
    STOP: 3,
  },
  // 定时任务触发类型
  SCHEDULE_TRIGGER_TYPE: {
    // 任务触发
    TASK: 0,
    // 手动出发
    MANUAL: 1,
  },
  // 定时任务执行状态
  SCHEDULE_EXECUTION_STATUS: {
    // 执行中
    RUN: 0,
    // 执行完成
    END: 1,
  },
  // 运行模式
  SCHEDULE_RUN_MODE: {
    BEAN: 0,
    SHELL: 1,
  },
  // 任务删除状态
  SCHEDULE_DELETE: {
    // 删除
    DELETE: -1,
    // 正常
    MANUAL: 0,
  },
  // 时间片大小  60min
  SCHEDULE_INTERVAL_TIME: {
    time: 60,
  },
  // 监控任务是否上线  下线
  ONLINETYPE: {
    OFFLINE: 3, // 下线
    ONLINE: 2, // 上线
  },
  // 是否开启数据同步
  DAP_SYNC_STATUS: {
    // 开启同步
    SYNC: 1,
    // 关闭同步
    UNSYNC: 0,
  },
  // 是否开启转化率监控报警
  TRANSFER_STATUS: {
    // 开启同步
    on: 1,
    // 关闭同步
    off: 0,
  },
  ERROR_STATUS: {
    100013: 100013,
    100012: 100012,
    11001: 11001,
  },
  // 证书监控状态
  CERTIFICATE_MONITOR_STATUS: {
    // 上线状态
    on: 1,
    // 下线状态
    off: 0,
  },
  // 报警级别对应的钉钉签名
  MONITOR_LEVEL_STATUS:{
    'P0':{
      dingAccessToken:'e80436bf0bdbd4253466c9afd7b604cc881f3e178a539af0c6c3d9d1fcfde1ed',
      dingSecret:'SECcb73e78462e25d96683a0e7e956559e3b86eb7956ee06717762e385dd0803584'
    },
    'P1':{
      dingAccessToken:'af9ae1169d87781242b90f556a34c2b6db21488b32f1252d6b87bcfaee4ce1b4',
      dingSecret:'SEC3e2f708544b58f7df4979c5d0356af1a5e0491e39222afa39ba4028536329c82'
    }
  }

};
module.exports = CONSTANTS;
