"use strict";

const Controller = require("egg").Controller;

class ProjectController extends Controller {
  // 获取项目列表
  async getProjectList() {
    function handleWhere(queryParams) {
      where = " where ";
      Object.keys(queryParams).forEach((key, index) => {
        if (
          index != Object.keys(queryParams).length - 1 &&
          Object.keys(queryParams).length != 1
        ) {
          
        } else {
          where = where + `projects.${key} LIKE '%${queryParams[key]}%'`;
        }
      });
    }
    const { ctx } = this;
    let { current = "1", pageSize = "10", ...queryParams } = ctx.request.query;
    current = Number(current);
    pageSize = Number(pageSize);
    let where = "";
    if (JSON.stringify(queryParams) != "{}") {
      handleWhere(queryParams);
    } else {
      where = "";
    }
    try {
      const sql =
        JSON.stringify(queryParams) != "{}"
          ? `
          select count(1) as num from (select distinct projects.projectId from task_list right join projects on projects.projectId=task_list.projectId 
            ${where}) as a
      ` : `
        select count(1) as num from (select distinct projects.projectId from task_list right join projects on projects.projectId=task_list.projectId 
        ) as a
      `;
      const sql2 = `
        select sum(task_list.onlineType!=1) as allCount,sum(task_list.onlineType=2) as activeCount, projects.projectId, projects.projectName from task_list right join projects on projects.projectId=task_list.projectId ${where} group by projects.projectId ORDER BY projects.projectId DESC LIMIT ${
          (current - 1) * pageSize
        },${pageSize}
      `;
      const num = await ctx.app.mysql.query(sql);
      console.log(num)
      const list = await ctx.app.mysql.query(sql2);
      ctx.body = {
        msg: "",
        status: 200,
        data: {
          list,
          total: num[0].num,
          pages: Math.ceil(num[0].num / pageSize),
        },
      };
    } catch (error) {
      return (ctx.body = {
        msg: "操作失败" + error.sqlMessage,
        status: 100,
        data: {},
      });
    }
  }

  // 新增、编辑项目: 项目Id ? 编辑 : 修改
  async addProject() {
    const { ctx, app } = this;
    const { projectName, projectId } = ctx.request.body;

    try {
      let isSuccess;
      let result;

      if (projectId) {
        const row = {
          projectName,
        };
        const options = {
          where: { projectId },
        };
        result = await app.mysql.update("projects", row, options);
        isSuccess = result.affectedRows === 1;
      } else {
        const row = {
          projectName,
        };
        result = await app.mysql.insert("projects", row);
        isSuccess = result.affectedRows === 1;
      }

      if (isSuccess) {
        return (ctx.body = {
          msg: "操作成功",
          status: 200,
          data: "",
        });
      } else {
        return (ctx.body = {
          msg: "操作失败",
          status: 100,
          data: "",
        });
      }
    } catch (error) {
      return (ctx.body = {
        msg: "操作失败：" + error.sqlMessage,
        status: 100,
        data: "",
      });
    }
  }
}

module.exports = ProjectController;
