"use strict";

const Controller = require("egg").Controller;
const md5 = require("md5");
const loginRule = {
  userName: "string",
  password: "string",
};
class HomeController extends Controller {
  async login() {
    const { ctx, app } = this;
    try {
      // 表单值校验
      ctx.validate(loginRule, ctx.request.body);
    } catch (error) {
      // 表单值校验未通过-返回结果
      return (ctx.body = {
        msg:
          "登录失败：" + error.errors[0].field + " " + error.errors[0].message,
        status: 100,
        data: "",
      });
    }
    const { userName, password } = ctx.request.body;
    // const { cookie } = ctx.request.header;
    try{
      const user = await ctx.app.mysql.select("users", {
        where: {
          userName,
          password: md5(password),
        },
        columns: ["userId", "userName", "role", "email","status"],
        limit: 1, // 返回数据量
        offset: 0, // 数据偏移量
      });
      if (user.length>0) {
        if(user[0].status === 0){
          return ctx.body = {
            msg: "该用户已经被禁用",
            status: 408,
            data: {},
          };

        }
        const token = ctx.app.jwt.sign(
          {
            ...ctx.request.body,
          },
          app.config.jwt.secret,
          {
            expiresIn: 60 * 60 * 24, // 时间根据自己定，具体可参考jsonwebtoken插件官方说明
          }
        );
  
        ctx.cookies.set("token", token, {
          maxAge: 60 * 60 * 24, //cookie存储一天 设置过期时间后关闭浏览器重新打开cookie还存在
          path: "/",
          httpOnly: false,
          signed: false,
        });
        ctx.body = {
          msg: "登录成功",
          status: 200,
          data: {...user[0], token},
        };
      } else {
        ctx.body = {
          msg: "登录失败",
          status: 100,
          data: null,
        };
      }

    }catch(e){
      ctx.body = {
        msg: "登录失败",
        status: 100,
        data: null,
      };
    }
  }
}

module.exports = HomeController;
