const Controller = require("egg").Controller;
class TransferController extends Controller {
  // 转化率监控列表
  async transferList() {
    function handleWhere(queryParams) {
      where = " where ";
      const map = ["modelName"];
      Object.keys(queryParams).forEach((key, index) => {
        if (
          index != Object.keys(queryParams).length - 1 &&
          Object.keys(queryParams).length != 1
        ) {
          if (map.includes(key)) {
            where =
              where +
              `product_model_basic.${key} LIKE '%${queryParams[key]}%' AND `;
          } else {
            where = where + `transfer.${key} LIKE '%${queryParams[key]}%' AND `;
          }
        } else {
          if (map.includes(key)) {
            where =
              where + `product_model_basic.${key} LIKE '%${queryParams[key]}%'`;
          } else {
            where = where + `transfer.${key} LIKE '%${queryParams[key]}%'`;
          }
        }
      });
    }
    const { ctx } = this;
    let { current = "1", pageSize = "10", ...queryParams } = ctx.request.query;
    current = Number(current);
    pageSize = Number(pageSize);
    let where = "";
    if (JSON.stringify(queryParams) != "{}") {
      handleWhere(queryParams);
    } else {
      where = "";
    }
    try {
      const sql =
        JSON.stringify(queryParams) != "{}"
          ? `
       SELECT 
         count(*) as num 
       FROM 
       transfer right join product_model_basic on transfer.modelId=product_model_basic.modelId ${where}
     `
          : `
     SELECT 
       count(*) as num 
     FROM 
     transfer right join product_model_basic on transfer.modelId=product_model_basic.modelId
   `;

      const sql2 = `
      select * from transfer right join product_model_basic on transfer.modelId=product_model_basic.modelId ${where} LIMIT ${
        (current - 1) * pageSize
      },${pageSize}`;
      const num = await ctx.app.mysql.query(sql);
      const list = await ctx.app.mysql.query(sql2);
      ctx.body = {
        msg: "",
        status: 200,
        data: {
          list,
          total: num[0].num,
          pages: Math.ceil(num[0].num / pageSize),
        },
      };
    } catch (error) {
      return (ctx.body = {
        msg: "操作失败" + error.sqlMessage,
        status: 100,
        data: {},
      });
    }
  }
  // 转化率监控配置
  async transferConfig() {
    const { ctx, app } = this;
    const {
      transferId,
      email,
      upPercentage,
      downPercentage,
      dingAccessToken,
      dingSecret,
    } = ctx.request.body;
    try {
      const row = {
        email,
        upPercentage,
        downPercentage,
        dingAccessToken,
        dingSecret,
      };
      const options = {
        where: { transferId },
      };
      await app.mysql.update("transfer", row, options);
      // 判断当前的配置是否开启了报警通知， 如开启： 发起定时任务  如关闭  停掉定时任务
      return (ctx.body = {
        msg: "操作成功",
        status: 200,
        data: {},
      });
    } catch (error) {
      console.log(error);
      return (ctx.body = {
        msg: "操作失败" + error.sqlMessage,
        status: 100,
        data: {},
      });
    }
  }
  // 转化率监控详情
  async transferDetail() {
    const { ctx } = this;
    const { transferId } = ctx.request.query;
    if (!transferId) {
      return (ctx.body = {
        msg: "操作失败",
        status: 100,
        data: {},
      });
    } else {
      try {
        const detail = await this.app.mysql.get("transfer", {
          transferId: Number(transferId),
        });
        return (ctx.body = {
          msg: "操作成功",
          status: 200,
          data: {
            ...detail,
          },
        });
      } catch (error) {
        return (ctx.body = {
          msg: "操作失败" + error.sqlMessage,
          status: 100,
          data: {},
        });
      }
    }
  }
  // 根据ModelId获取转化路径列表
  async getTransferListByModelId() {
    const { ctx } = this;
    const { modelId } = ctx.request.query;
    try {
      // 模型树数据
      const transferDetail = await this.app.mysql.select("transfer", {
        where: {
          modelId: modelId,
        },
      });
      return (ctx.body = {
        msg: "操作成功",
        status: 200,
        data: {
          transferDetail,
        },
      });
    } catch (err) {
      return (ctx.body = {
        msg: "操作失败" + err.sqlMessage,
        status: 100,
        data: {},
      });
    }
  }
  // 转化率监控上下线
  async transferOnline() {
    const { ctx } = this;
    const { transferId, isAlert, modelName } = ctx.request.body;
    if (isAlert === 0) {
      // 下线
      try {
        const result = await this.app.mysql.update(
          "transfer",
          {
            isAlert: isAlert,
          },
          { where: { transferId: transferId } }
        );
        if (result.affectedRows === 1) {
          const transferItem = await this.app.mysql.get("transfer", {
            transferId: transferId,
          });
          transferItem.modelName = modelName;
          await this.ctx.helper.cancelTransferSchedule(
            transferItem.modelId,
            transferItem.transferId
          );
          return (ctx.body = {
            msg: "操作成功",
            status: 200,
            data: {},
          });
        }
      } catch (error) {
        return (ctx.body = {
          msg: "操作失败" + error.sqlMessage,
          status: 100,
          data: {},
        });
      }
    } else if (isAlert === 1) {
      // 上线
      try {
        const result = await this.app.mysql.update(
          "transfer",
          {
            isAlert: isAlert,
          },
          { where: { transferId: transferId } }
        );
        if (result.affectedRows === 1) {
          const transferItem = await this.app.mysql.get("transfer", {
            transferId: transferId,
          });
          await this.ctx.helper.generateTransferSchedule(transferItem);
          return (ctx.body = {
            msg: "操作成功",
            status: 200,
            data: {},
          });
        }
      } catch (error) {
        return (ctx.body = {
          msg: "操作失败" + error.sqlMessage,
          status: 100,
          data: {},
        });
      }
    }
  }
  // 模型下是否有监控开启的转化路径
  async transferIsAlert() {
    const { ctx } = this;
    const { modelId } = ctx.request.query;
    let isAlert;
    try {
      const alertArr = await this.app.mysql.select("transfer", {
        where: {
          modelId: modelId,
          isAlert: 1,
        },
      });
      if (alertArr && alertArr.length > 0) {
        isAlert = true;
      } else {
        isAlert = false;
      }
      return (ctx.body = {
        msg: "操作成功",
        status: 200,
        data: {
          isAlert: isAlert,
        },
      });
    } catch (error) {
      console.log(error);
      return (ctx.body = {
        msg: "操作失败" + error.sqlMessage,
        status: 100,
        data: {},
      });
    }
  }
}
module.exports = TransferController;
