"use strict";
const SCHEDULESTACKS = Symbol("Application#scheduleStacks");
const DAPSCHEDULESTACKS = Symbol("Application#dapscheduleStacks");
const TRANSFESTACKS = Symbol("Application#transferStacks");

const CERTIFICATESTACKS = Symbol("Application#certificateStacks");
const REDLOCK = Symbol("Application#redlock");
/**
 * Application扩展
 */
module.exports = {
  /**
   * redis锁
   */
  get redlock() {
    if (!this[REDLOCK]) {
      this[REDLOCK] = {};
      this[REDLOCK].lock = async (key, value, ttl) => {
        console.log(this.redis, 33333);
        return await this.redis.set(key, Number(value), "EX", ttl, "NX");
      };
      this[REDLOCK].unlock = async (key) => {
        return await this.redis.del(key);
      };
    }
    return this[REDLOCK];
  },
  /**
   * 用于存放定时任务的堆栈
   */
  get scheduleStacks() {
    if (!this[SCHEDULESTACKS]) {
      this[SCHEDULESTACKS] = {};
    }
    return this[SCHEDULESTACKS];
  },

  /**
   * 用于存放dap同步数据定时任务的堆栈
   */
  get dapscheduleStacks() {
    if (!this[DAPSCHEDULESTACKS]) {
      this[DAPSCHEDULESTACKS] = {};
    }
    return this[DAPSCHEDULESTACKS];
  },
  /**
   * 用于存放转化路径监控定时任务的堆栈
   */
  get transferStacks() {
    if (!this[TRANSFESTACKS]) {
      this[TRANSFESTACKS] = {};
    }
    return this[TRANSFESTACKS];
  },
  
  /**
   * 用于存放证书监控定时任务的堆栈
   */

  get certificateStacks() {
    if (!this[CERTIFICATESTACKS]) {
      this[CERTIFICATESTACKS] = {};
    }
    return this[CERTIFICATESTACKS];
  },
};
