const Service = require('egg').Service

class curlServerService extends Service {

  /**
   * 调用curl服务API（HTTP）
   * @param { String } url API路径
   * @param { Object } options curl的配置信息
   * @return { Object } 返回请求结果数据
   */
  async tarsServerHttp(url = '', options = {}) {
    const { ctx } = this
    if (!url) {
      ctx.throw(400, '缺少请求Api路径', { code: 400201 })
    }
    const {
      method = 'GET',
      data = {},
      dataType = 'text/html',
      headers = {
        'Content-Type': 'application/json'
      },
      timeout = 10 * 1000,
      nestedQuerystring = false,
      // 此处只列了常见属性，有需要新增参数的，在此处添加
      // 更多配置，查看 https://www.npmjs.com/package/urllib
    } = options
    try{
      const res = await ctx.curl(
        url,
        {
          method,
          data,
          dataType,
          headers,
          timeout,
          nestedQuerystring,
        }
      )
      return res
    }catch(e){
      return e
    }
  }
}
module.exports = curlServerService
