"use strict";

const Service = require("egg").Service;
const dayjs = require("dayjs");
class TransferService extends Service {
  async transferMonitor(scheduleItem) {
    const { ctx } = this;
    const {
      transferId,
      modelId,
      fromEventName,
      toEventName,
      email,
      upPercentage,
      downPercentage,
      dingAccessToken,
      dingSecret,
      fromCategory,
      toCategory,
    } = scheduleItem;
    const scheduleItemArr = [scheduleItem];
    const modelItem = await this.app.mysql.get("product_model_basic", {
      modelId: modelId,
    });
    const implaPath = this.config.implaPath;
    const afterDayData = {
      appNames: [modelItem.appName],
      events: [fromEventName, toEventName],
      categorys: [...new Set([fromCategory, toCategory])],
      opdate: dayjs(new Date()).subtract(1, "day").format("YYYY-MM-DD"),
    };
    const res = await ctx.curl(`${implaPath}/getDotStatisticByEvts`, {
      method: "POST",
      contentType: "json",
      timeout: 10000,
      data: afterDayData,
      dataType: "json",
    });
    if (res.data.Result === 1) {
      scheduleItemArr.forEach(async (i) => {
        res.data.data.forEach((j) => {
          if (i.fromEventName === j.event && i.fromCategory === j.category) {
            i.afterFromVal1 = j.val1;
            i.afterFromVal2 = j.val2;
          }
          if (i.toEventName === j.event && i.toCategory === j.category) {
            i.afterToVal1 = j.val1;
            i.afterToVal2 = j.val2;
          }
        });
      });
      if (!Number(scheduleItemArr[0].afterFromVal1)) {
        scheduleItemArr[0].afterFromVal1 = 0;
      }
      if (!Number(scheduleItemArr[0].afterFromVal2)) {
        scheduleItemArr[0].afterFromVal2 = 0;
      }
      if (!Number(scheduleItemArr[0].afterToVal1)) {
        scheduleItemArr[0].afterToVal1 = 0;
      }
      if (!Number(scheduleItemArr[0].afterToVal2)) {
        scheduleItemArr[0].afterToVal2 = 0;
      }
      if (Number(scheduleItemArr[0].afterFromVal1)) {
        scheduleItemArr[0].afterTransferUser = await ctx.helper.div(
          scheduleItemArr[0].afterToVal1,
          scheduleItemArr[0].afterFromVal1
        );
        scheduleItemArr[0].afterTransferUser = scheduleItemArr[0].afterTransferUser.toFixed(4);
      } else {
        scheduleItemArr[0].afterTransferUser = 0;
      }
      if (scheduleItemArr[0].afterFromVal2) {
        scheduleItemArr[0].afterTransferTimes = await ctx.helper.div(
          scheduleItemArr[0].afterToVal2,
          scheduleItemArr[0].afterFromVal2
        );
        scheduleItemArr[0].afterTransferTimes = scheduleItemArr[0].afterTransferTimes.toFixed(4);
      } else {
        scheduleItemArr[0].afterTransferTimes = 0;
      }
    }
    this.logger.info(
      `afterToVal1 ${scheduleItemArr[0].afterToVal1}`,
      `afterFromVal1 ${scheduleItemArr[0].afterFromVal1}`,
      `昨天统计数据：：转化率：${scheduleItemArr[0].afterTransferUser}`
    );
    const beforeDayData = {
      appNames: [modelItem.appName],
      events: [fromEventName, toEventName],
      categorys: [...new Set([fromCategory, toCategory])],
      opdate: dayjs(new Date()).subtract(2, "day").format("YYYY-MM-DD"),
    };
    const res2 = await ctx.curl(`${implaPath}/getDotStatisticByEvts`, {
      method: "POST",
      contentType: "json",
      timeout: 10000,
      data: beforeDayData,
      dataType: "json",
    });
    if (res2.data.Result === 1) {
      scheduleItemArr.forEach(async (i) => {
        res2.data.data.forEach((j) => {
          if (i.fromEventName === j.event && i.fromCategory === j.category) {
            i.beforeFromVal1 = j.val1;
            i.beforeFromVal2 = j.val2;
          }
          if (i.toEventName === j.event && i.toCategory === j.category) {
            i.beforeToVal1 = j.val1;
            i.beforeToVal2 = j.val2;
          }
        });
      });
      if (!Number(scheduleItemArr[0].beforeFromVal1)) {
        scheduleItemArr[0].beforeFromVal1 = 0;
      }
      if (!Number(scheduleItemArr[0].beforeFromVal2)) {
        scheduleItemArr[0].beforeFromVal2 = 0;
      }
      if (!Number(scheduleItemArr[0].beforeToVal1)) {
        scheduleItemArr[0].beforeToVal1 = 0;
      }
      if (!Number(scheduleItemArr[0].beforeToVal2)) {
        scheduleItemArr[0].beforeToVal2 = 0;
      }
      if (Number(scheduleItemArr[0].beforeFromVal1)) {
        scheduleItemArr[0].beforeTransferUser = await ctx.helper.div(
          scheduleItemArr[0].beforeToVal1,
          scheduleItemArr[0].beforeFromVal1
        ); // 前天人数转化率
        scheduleItemArr[0].beforeTransferUser = scheduleItemArr[0].beforeTransferUser.toFixed(4);
      } else {
        scheduleItemArr[0].beforeTransferUser = 0;
      }
      if (scheduleItemArr[0].beforeFromVal2) {
        scheduleItemArr[0].beforeTransferTimes = await ctx.helper.div(
          scheduleItemArr[0].beforeToVal2,
          scheduleItemArr[0].beforeFromVal2
        ); // 前天次数转化率
        scheduleItemArr[0].beforeTransferTimes = scheduleItemArr[0].beforeTransferTimes.toFixed(4);
      } else {
        scheduleItemArr[0].beforeTransferTimes = 0;
      }
    }
    this.logger.info(
      `beforeToVal1 ${scheduleItemArr[0].beforeToVal1}`,
      `beforeFromVal1 ${scheduleItemArr[0].beforeFromVal1}`,
      `前天统计数据：：转化率：${scheduleItemArr[0].beforeTransferUser}`
    );
    const transeferobj = scheduleItemArr[0];
    console.log(transeferobj, 55555);
    if (transeferobj.beforeTransferUser > transeferobj.afterTransferUser) {
      // 如果前天人数转化率大于昨天人数转化率  (说明转化率在下降)
      const differenceNum = await ctx.helper.sun(
        transeferobj.beforeTransferUser,
        transeferobj.afterTransferUser
      );
      const downNum = downPercentage / 100;
      console.log(differenceNum, 6666);
      // 如果下降的差值大于前天转化率乘以下降百分比
      if (
        differenceNum >=
        (await ctx.helper.mul(transeferobj.beforeTransferUser, downNum))
      ) {
        this.logger.info(
          `报警`
        );
        const subject = "数据模型转化路径转化率监控警告通知";
        const title = "数据模型转化路径转化率监控警告通知";
        const text = "前端团队";
        const at = {
          // 用户@具体用户
          atMobiles: ["durant.shi@uptech.ai"],
          isAtAll: false,
        };
        // 邮件模板格式
        const html = `<h2>数据模型转化路径转化率监控报警通知</h2><br/>
         <p>
          <span>数据模型</span>：<span>${modelItem.modelName}</span>
         </p>
         <p>
          <span>转化路径</span>：<span>${fromEventName}->${toEventName}</span>
         </p>
         <p>
          <span>转化率统计时间:</span>：<span>${beforeDayData.opdate}->${
          afterDayData.opdate
        }</span>
         </p>
         <p style="color:red">
           <span>转化率从${await ctx.helper.mul(
             transeferobj.beforeTransferUser,
             100
           )}%下降到${await ctx.helper.mul(
          transeferobj.afterTransferUser,
          100
        )}%</span>
         </p>
         `;
        // 钉钉推送格式
        const markDown =
          `## ${subject} \n` +
          `> 数据模型：${modelItem.modelName} \n\n` +
          `> 转化路径: ${fromEventName}->${toEventName} \n\n` +
          `> 转化率统计时间：${beforeDayData.opdate}->${afterDayData.opdate} \n\n` +
          `> 转化率从 ${await ctx.helper.mul(
            transeferobj.beforeTransferUser,
            100
          )}%下降到${await ctx.helper.mul(
            transeferobj.afterTransferUser,
            100
          )}% \n\n`;
        await this.service.tool.sendMail(email, subject, text, html);
        const robot = await this.service.dingtalkService.DingTalk(
          dingAccessToken,
          dingSecret
        );
        robot.markdown(title, markDown, at);
      }
    } else if (
      transeferobj.afterTransferUser > transeferobj.beforeTransferUser
    ) {
      // 如果前天人数转化率小于昨天人数转化率 (说明转化率在上升)
      const differenceNum = await ctx.helper.sun(
        transeferobj.afterTransferUser,
        transeferobj.beforeTransferUser
      );
      const upNum = upPercentage / 100;
      // 如果上升的差值大于等于前天转化率乘以上升百分比
      if (
        differenceNum >=
        (await ctx.helper.mul(transeferobj.beforeTransferUser, upNum))
      ) {
        this.logger.info(
          `报喜`
        );
        const subject = "数据模型转化路径转化率监控报喜通知";
        const title = "数据模型转化路径转化率监控报喜通知";
        const text = "前端团队";
        // 邮件模板格式
        const html = `<h2>数据模型转化路径转化率监控通知</h2><br/>
         <p>
          <span>数据模型</span>：<span>${modelItem.modelName}</span>
         </p>
         <p>
          <span>转化路径</span>：<span>${fromEventName}->${toEventName}</span>
         </p>
         <p>
          <span>转化率统计时间:</span>：<span>${beforeDayData.opdate}->${
          afterDayData.opdate
        }</span>
         </p>
         <p style="color:green">
           <span>转化率从${await ctx.helper.mul(
             transeferobj.beforeTransferUser,
             100
           )}%上升到${await ctx.helper.mul(
          transeferobj.afterTransferUser,
          100
        )}%</span>
         </p>
         `;
        const markDown =
          `## ${subject} \n` +
          `> 数据模型：${modelItem.modelName} \n\n` +
          `> 转化路径: ${fromEventName}->${toEventName} \n\n` +
          `> 转化率统计时间：${beforeDayData.opdate}->${afterDayData.opdate} \n\n` +
          `> 转化率从 ${await ctx.helper.mul(
            transeferobj.beforeTransferUser,
            100
          )}%上升到${await ctx.helper.mul(
            transeferobj.afterTransferUser,
            100
          )}% \n\n`;
        const at = {
          // 用户@具体用户
          atMobiles: ["durant.shi@uptech.ai"],
          isAtAll: false,
        };
        await this.service.tool.sendMail(email, subject, text, html);
        const robot = await this.service.dingtalkService.DingTalk(
          dingAccessToken,
          dingSecret
        );
        robot.markdown(title, markDown, at);
      }
    }
  }
}
module.exports = TransferService;
