/* eslint valid-jsdoc: "off" */
"use strict";
const path = require("path");

/**
 * @param {Egg.EggAppInfo} appInfo app info
 */
module.exports = (appInfo) => {
  /**
   * built-in config
   * @type {Egg.EggAppConfig}
   **/
  const config = (exports = {});
  config.static = {
    // 静态化访问前缀,如：`http://127.0.0.1:7001/static/images/logo.png`
    prefix: "/static",
  };
  // config.assets = {
  //   templatePath: path.join(appInfo.baseDir, "app/view/index.html"),
  //   templateViewEngine: "nunjucks",
  // };
  // use for cookie sign key, should change to your own and keep security
  config.keys = appInfo.name + "_1649681327470_3079";
  // add your middleware config here
  config.middleware = ["auth"];
  // add your user config here
  const userConfig = {
    // myAppName: 'egg',
  };
  config.security = {
    // csrf: {
    //   queryName: '_csrf', // 通过 query 传递 CSRF token 的默认字段为 _csrf
    //   bodyName: '_csrf', // 通过 body 传递 CSRF token 的默认字段为 _csrf
    // },
    csrf: { enable: false },
  };
  config.mysql = {
    // dn库
    client: {
      host: "127.0.0.1", // 自己的数据库host
      port: "3306", // 自己的连接端口
      user: "root", // 可以使用root
      password: "Dingtone@me123456", // 数据库密码
      database: "front_admin", // 要连接的数据库名称
      // debug: true //打印sql
    },
    app: true,
    agent: false,
  };
  /** redis配置 */
  config.redis = {
    client: {
      port: 6379,
      host: "54.215.36.121",
      password: "",
      db: 0,
    },
  };
  config.view = {
    defaultViewEngine: "nunjucks",
    mapping: {
      ".html": "nunjucks",
    },
  };
  config.implaPath = "http://127.0.0.1:7002";
  config.jwt = {
    secret: "369874125nice",
  };

  return {
    ...config,
    ...userConfig,
  };
};
